#!/bin/bash

# set classpath
DYNCLASSPATH=''
for i in $( ls ../lib ); do
	DYNCLASSPATH=$DYNCLASSPATH':'../lib/$i
done
# echo "Dynamic Classpath: "$DYNCLASSPATH

# construct classpath
export CLASSPATH='.:'$CLASSPATH':'$DYNCLASSPATH

PROFILER_DIR='/home/marcel/work/profiler/profile'

# Java Options
# JAVA_OPTIONS='-javaagent:'$PROFILER_DIR'/profile.jar -Dprofile.properties='$PROFILER_DIR'/profile.properties'
# JAVA_OPTIONS='-agentpath:/home/marcel/work/yjp-9.0.7/bin/linux-x86-64/libyjpagent.so'
JAVA_OPTIONS=''
# echo 'Java Options: '$JAVA_OPTIONS

# Main Class
MAIN_CLASS='de.jiac.micro.internal.NodeLauncher'

# Main Class Parameters
MAIN_CLASS_PARAMETERS='-c de.jiac.micro.internal.latebind.config_agents_MAPCAgentNode'

#
# Java execution
#
echo $JAVA_HOME/bin/java $JAVA_OPTIONS $MAIN_CLASS $MAIN_CLASS_PARAMETERS

$JAVA_HOME/bin/java $JAVA_OPTIONS $MAIN_CLASS $MAIN_CLASS_PARAMETERS
