package de.tub.mapc;

public interface IMAPCConstants {
	public static final String SERVER_IP_KEY = "mapc-server-ip";
    public static final String SERVER_PORT_KEY = "mapc-server-port";
    public static final String TEAMNAME_KEY = "mapc-agent-teamname";
    public static final String USERNAME_KEY = "mapc-agent-username";
    public static final String PASSWORD_KEY = "mapc-agent-password";
    public static final String AGENT_ID_KEY = "mapc-agent-id";  
    public static final String MESSAGE_MONITORAGENT_RESPONSE = "IAmMonitorAgent";
    public static final String MESSAGE_MONITORAGENT_REQUEST = "WhoIsMonitorAgent";
    public static final String MESSAGE_COORDINATOR_REQUEST = "WhoIsCoordinator";
    public static final String MESSAGE_COORDINATOR_RESPONSE = "IAmCoordinator";
    public static final String MESSAGE_NEED_GOAL = "HowCanIHelp";
    public static final String MESSAGE_GOAL_UNREACHABLE = "CannotReachTheGoal";
    public static final String MESSAGE_RESET = "ResetForNewSimulation";
    public static final String MESSAGE_SWITCH_GOAL_ACHIEVED ="SwitchGoalAchieved";
    
    public static final String ACTION_NORTH = "north";
	public static final String ACTION_SOUTH = "south";
	public static final String ACTION_WEST  = "west";
	public static final String ACTION_EAST  = "east";
	public static final String ACTION_NORTHEAST = "northeast";
	public static final String ACTION_SOUTHEAST = "southeast";
	public static final String ACTION_NORTHWEST  = "northwest";
	public static final String ACTION_SOUTHWEST  = "southwest";
	
	public static final String ACTION_SKIP = "skip";
	public static final String GOAL_UNREACHABLE = "TheGoalIsUnreachable";
	
	public static final String PATH_BLOCKED = "ThePathIsBlocked";
	public static final String PATH_FENCEAHEAD = "ClosedFenceAhead";
	public static final String PATH_NOTFOUND = "NoPathWasFound";
	public static final String PATH_ERROR = "anErrorOccured";
	
	public static final int TYPE_COW = 0;
	public static final int TYPE_EMPTY = 1;
	public static final int TYPE_ENEMY = 2;
	public static final int TYPE_PARTNER = 3;
	public static final int TYPE_CORRAL = 4;
	public static final int TYPE_ENEMY_CORRAL = 5;
	public static final int TYPE_TREE = 6;
	public static final int TYPE_FENCE = 7;
	public static final int TYPE_SWITCH = 8;
	public static final int TYPE_UNKNOWN = 9;
	public static final int TYPE_OPEN_FENCE = 10;
	public static final int TYPE_COUNT= 11;
	
	public static final int ROLE_NONE = 0;
	public static final int ROLE_DRIVER = 1;
	public static final int ROLE_MINION = 2;
}
