//package de.tub.mapc.components.monitoragent;
//
//import java.io.IOException;
//import java.util.Enumeration;
//
//import org.slf4j.Logger;
//
//import de.jiac.micro.agent.AbstractReactiveBehaviour;
//import de.jiac.micro.agent.handle.ICommunicationHandle;
//import de.jiac.micro.core.IAgent;
//import de.jiac.micro.core.feature.ILifecycleAware;
//import de.jiac.micro.core.io.IMessage;
//import de.jiac.micro.core.io.IMulticastAddress;
//import de.jiac.micro.core.scope.AgentScope;
//import de.tub.mapc.IMAPCConstants;
//import de.tub.mapc.knowledge.Gridworld;
//import de.tub.mapc.knowledge.Perception;
//import de.tub.mapc.monitor.AgentMonitor;
//
//public class MonitorElement extends AbstractReactiveBehaviour implements ILifecycleAware {
//
//	private static final MonitorElement INSTANCE = new MonitorElement();
//	private ICommunicationHandle _communicationHandle;
//	private Logger _logger;
//	private IMulticastAddress _address;
//	private AgentMonitor monitorwindow;
//	private Gridworld firstWorld;
//	private boolean initialized = false;
//	
//	public static MonitorElement getInstance(){
//		return INSTANCE;
//	}
//	
//	@SuppressWarnings("unchecked")
//	@Override
//	protected Class[] filterDataTypes() {
//		// the new information comes from messages sent by other agents
//		return new Class[] {IMessage.class};
//	}
//
//	@SuppressWarnings("unchecked")
//	@Override
//	protected void runShort(Enumeration sensorReadings) {
//		if (!initialized && (firstWorld != null)){
//			initializeMonitor(firstWorld);
//		}
////		while (sensorReadings.hasMoreElements()) {
////			IMessage message = (IMessage) sensorReadings.nextElement();
////			// give the message to the window
////			if(getInstance().monitorwindow != null){
////				String address = message.getHeader(IMessage.DefaultHeader.SOURCE_ADDRESS);
////				Object content = message.getContent();
////				getInstance().monitorwindow.addAgentMessage(address,content);
////			}
////			
////			Object content = message.getContent();
////			if (content instanceof Perception){
////				Perception g = (Perception) content;
////				getInstance().updateMonitor(g);//.getGridInfo()
////			} else if(content instanceof Gridworld){
////				Gridworld g = (Gridworld) content;
////				getInstance().initializeMonitor(g);
////				
////			}
////			else if(content instanceof String){
////				String s = (String) content;
////				if(s.equals(IMAPCConstants.MESSAGE_RESET)){
////					//we have to prepare for a new simulation
////					getInstance().reset();
////				}
////	//				if(s.equals(IMAPCConstants.MESSAGE_MONITORAGENT_REQUEST)){
////	//					// got the monitor request message, send response Message
////	//					try{
////	//						sendMonitorResponse();
////	//					} catch (IOException ioe) {
////	//						_logger.error("Could not send Monitor Response", ioe);
////	//					}
////	//				} 
////			}
////		}
//	}
//	
//	
//	public void initializeMonitor(Gridworld world){
//		// TODO is jetzt erstmal so, weil er das sonst 20 mal macht...
//		// spaeter ueberlegen ob es drinbleiben soll oder raus kann
//		
//		_logger.debug("initializing monitor: "+toString());
//		// Initialize the window
//		if (monitorwindow == null){
//			monitorwindow = new AgentMonitor(world);
//			initialized = true;
//		}
//	}
//	
//	public void addWorld(Gridworld world){
//		if (firstWorld == null)
//			firstWorld = world;
//	}
//	
//	
//	/**
//	 * resets the monitorwindow
//	 */
//	public void reset(){
//		//TODO Fenster schliessen 
//		monitorwindow = null;
//		initialized = false;
//		firstWorld = null;
//	}
//	
//	public void updateMonitor(Perception p){
//		if (monitorwindow != null){
//			monitorwindow.update(p);
////			getInstance()._logger.debug("UPDATING! "+getInstance().toString());			
//		}
//	}
//	
//	public void updateMonitor(Object p, String agentID){
//		if (monitorwindow != null){
//			monitorwindow.update(p, agentID);
////			getInstance()._logger.debug("UPDATING! "+getInstance().toString());			
//		}
//	}
//
////	@Override
////	public void start() {
////        super.start();
////        
//		// Referenz auf den Agenten
////		IAgent agent = AgentScope.getAgentReference();
//		// Referenz auf die Kommunikationsschnittstelle
////		_communicationHandle = (ICommunicationHandle) agent.getHandle(ICommunicationHandle.class);
//		// Referenz auf den Logger
////		_logger = agent.getLogger("Monitor");
////		
//		// define the group
////		try {
//			// use the teamname as groupname for communication
////			String groupName = (String) agent.getProperty(IMAPCConstants.TEAMNAME_KEY);
//			// get the address for this group
////			_address = _communicationHandle.getMulticastAddressForName(groupName);
////			 join the group
////			_communicationHandle.joinGroup(_address);
////
////			
////			_communicationHandle.joinGroup(_communicationHandle.getMulticastAddressForName("monitor"));
////			
////			// tell teh other agents that I am the Monitor
////			sendMonitorResponse();
////		} catch (IOException e) {
////			_logger.error("Could not join the team group", e);
////		}
////	}
//	
////	/**
////	 * sends a special String to all agents, so they know the address
////	 * of the monitoragent 
////	 * @throws IOException
////	 */
////	private void sendMonitorResponse() throws IOException{
////		IMessage m = _communicationHandle.createMessage();
////		m.setContent(IMAPCConstants.MESSAGE_MONITORAGENT_RESPONSE);
////		_communicationHandle.sendMessage(_address, m);
////	}
////	
//
////	@Override
////	public void stop() {
//		// Der Agent faehrt runter -> wir brauchen die Gruppe nicht mehr.
////		try {
////			_communicationHandle.leaveGroup(_address);
////		} catch (IOException e) {
////			_logger.error("Could not leave the team group", e);
////		}
////		
////		super.stop();
////	}
//	
//}
