package de.tub.mapc.knowledge;

import java.io.IOException;

import de.dailab.keks.io.IDeserialiser;
import de.dailab.keks.io.ISerialiser;
import de.jiac.micro.agent.memory.IFact;

/**
 * Ergebnisfakt fuer die Anmeldung am Contest-Server
 * wird nirgendwo weiter verwendet, aber irgendeinen Fakt musste man erstellen...
 * falls direkt nach dem login noch etwas geschehen soll, dann kann dieser Fakt in
 * einem AbstractReactiveBehaviour abgefragt werden
 * @author Erik
 *
 */
public class AuthenticationResult implements IFact {

	/**result of Authentication at Contest-Server*/
	private String result;
	
	public AuthenticationResult(String result) {
		this.result = result;
	}

	@Override
	public void deserialise(IDeserialiser arg0) throws IOException,
			ClassNotFoundException {
		result = arg0.readString();

	}

	@Override
	public void serialise(ISerialiser arg0) throws IOException {
		arg0.writeString(result);

	}

}
